<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: index.php
| Author: Driv3r
| Email: oprend@oprend.hu
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/header.php";

if (file_exists(INFUSIONS."help_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."help_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."help_panel/locale/English.php";
}

add_to_head("<link rel='stylesheet' href='".INFUSIONS."help_panel/styles.css' type='text/css' media='screen' />\n");
add_to_title($locale['global_200']." ".$locale['HELP_title']);

include INFUSIONS."help_panel/infusion_db.php";

if (isset($_GET['question_id']) && isnum($_GET['question_id'])) {
		global $userdata;

		opentable($locale['HELP_title']);
		
		$result = dbquery("SELECT hq.*, cat.help_cat_id, cat.help_cat_name, scat.help_scat_id, scat.help_scat_name, 
						  users.user_id, users.user_name, users.user_avatar FROM ".DB_HELP_Q." hq 
						  LEFT JOIN ".DB_HELP_CAT." cat ON hq.question_cat=cat.help_cat_id 
						  LEFT JOIN ".DB_HELP_SUBCAT." scat ON hq.question_scat=scat.help_scat_id 
						  LEFT JOIN ".DB_USERS." users ON hq.question_user_id=users.user_id 
						  WHERE question_id='".$_GET['question_id']."'");
		
		if (dbrows($result)) {
			while ($data = dbarray($result)) {
			
			// Define user avatar and name
				if ($data['user_avatar'] != NULL) {
						$quser_avatar = "<img src='".IMAGES."avatars/".$data['user_avatar']."' border='0' width='100px' height='100px' alt=''/>\n";
					} else {
						$quser_avatar = "<img src='".IMAGES."avatars/noavatar100.png' border='0' alt=''/>\n";
					}
					
					if ($data['user_name'] != NULL) {
						$quser_name = "<a href='".BASEDIR."profile.php?lookup=".$data['question_user_id']."'>".$data['user_name']."</a>";
					} else {
						$quser_name = $locale['HELP_user_unknown'];
					}
			
			// Helpers
			$solved = $data['question_solved'];
			$question_id = $data['question_id'];
			$question_user_id = $data['question_user_id'];
			
			$comments_count = dbcount("(answer_id)", DB_HELP_A, "question_id='".$data['question_id']."'");
			
			if ($solved == 1) {
				$table_style = "question-tbl-solved";
			} else {
				$table_style = "question-tbl";
			}
			
			// Layout
			echo "<table class='".$table_style."' width='100%' cellpadding='0' cellspacing='0' border='0'>\n";
			echo "<tr>\n<td class='question-tbl1' colspan='1' rowspan='2' style='text-align:center;vertical-align:top;width:110px;'>\n
			<div class='avatar'>".$quser_avatar."</div>".$quser_name."</td>\n";
			echo "<td class='question-tbl1'>\n<span style='font-size:1.6em;'>\n";
			if ($solved == 1) {echo $locale['HELP_question_solved']." ";}
			echo $data['question_title']."</span>\n<br />\n";
			echo "</td>\n";
			echo "<td style='width:64px;vertical-align:top;'>\n";
			if ($solved == 1) {
			echo "<img src='".$HELP_PATH."images/solved.png' alt='' />\n";
			} else {
			echo "<img src='".$HELP_PATH."images/help.png' alt='' />\n";
			}
			echo "</td>\n</tr>\n";
			echo "<tr>\n<td colspan='2' rowspan='1' class='question-tbl1' style='padding-bottom:8px;'>\n";
			echo parseubb(parsesmileys(nl2br($data['question_description'])));
			echo "</td>\n</tr>\n";
			echo "<tr>\n<td colspan='3' rowspan='1' class='question-tbl2'>\n
			<div style='float:left;'>\n";
			echo "<img src='".$HELP_PATH."images/cat.png' alt='' style='vertical-align:top;' title='".$locale['HELP_cat']."' /> <a href='".$HELP_PATH."cats.php?cat_id=".$data['question_cat']."'>".$data['help_cat_name']."</a>";
			if ($data['help_scat_id'] != NULL) {
				echo ", <a href='".$HELP_PATH."cats.php?scat_id=".$data['help_scat_id']."'>".$data['help_scat_name']."</a>\n";
			}
			if ($data['question_edittime'] > 0) {
				echo "<img src='".$HELP_PATH."images/edited.png' alt='' style='vertical-align:top;margin-left:8px;' title='".$locale['HELP_question_edittime']."' /> ".showdate("longdate", $data['question_edittime'])."\n";
			} else {
				echo "<img src='".$HELP_PATH."images/date.png' alt='' style='vertical-align:top;margin-left:8px;' title='".$locale['HELP_question_date']."' /> ".showdate("longdate", $data['question_datestamp'])."\n";
			}
			echo "<img src='".$HELP_PATH."images/views.png' alt='' style='vertical-align:top;margin-left:8px;' title='".$locale['HELP_question_views']."' /> ".$data['question_count']."\n";
			echo "<img src='".$HELP_PATH."images/answers.png' alt='' style='vertical-align:top;margin-left:8px;' title='".$locale['HELP_question_comments']."' /> ".$comments_count."\n";
			echo "</div>\n";
			echo "<div style='float:right;'>\n";
			if ($userdata['user_id'] == $question_user_id OR (iADMIN && checkrights("HLP"))) {
			echo "<a href='".$HELP_PATH."edit_question.php?question_id=".$_GET['question_id']."'><img src='".$HELP_PATH."images/edit.png' alt='' border='0' style='vertical-align:top;' /></a>\n";
			}
			if (iADMIN && checkrights("HLP")) {
			echo "<a href='".FUSION_SELF."?question_id=".$_GET['question_id']."&amp;action=delquestion' onclick=\"return confirm('".$locale['HELP_delete_warning']."');\"><img src='".$HELP_PATH."images/delete.png' alt='' border='0' style='vertical-align:top;' /></a>\n";
			}
			echo "</div>\n</td>\n</tr>\n";
			echo "</table>\n";
			
			// Add count to page views
			$add_count = dbquery("UPDATE ".DB_HELP_Q." SET question_count=question_count+1 WHERE question_id='".$data['question_id']."'");
			}
		} else {
			redirect(FUSION_SELF);
		}
		
		// Answers
		$result3 = dbquery("SELECT ha.*, users.user_id, users.user_name, users.user_avatar 
							FROM ".DB_HELP_A." ha 
							LEFT JOIN ".DB_USERS." users ON ha.answer_user_id=users.user_id 
							WHERE question_id='".$_GET['question_id']."' 
							ORDER BY answer_solution DESC, answer_datestamp ASC");
		
		if (dbrows($result3)) {
			while ($data = dbarray($result3)) {
			
			if ($data['user_avatar'] != NULL) {
				$cuser_avatar = "<img src='".IMAGES."avatars/".$data['user_avatar']."' border='0' alt=''/>\n";
				} else {
				$cuser_avatar = "<img src='".IMAGES."avatars/noavatar100.png' border='0' alt=''/>\n";
				}
					
				if ($data['user_name'] != NULL) {
					$cuser_name = "<a href='".BASEDIR."profile.php?lookup=".$data['answer_user_id']."'>".$data['user_name']."</a>";
				} else {
					$cuser_name = $locale['HELP_user_unknown'];
				}
			
			// Define style
			if ($data['answer_solution'] == 0) {
				$answer_wrap_style = "answer-avatar-wrap";
				$answer_style = "answer";
			} else {
				$answer_wrap_style = "answer-avatar-wrap-solved";
				$answer_style = "answer-solved";
			}
			
			// Get the ID of solution to check when deleting answer
			if ($data['answer_solution'] == "1") {
				$solution_answer_id = $data['answer_id'];
			} else {
				$solution_answer_id = "";
			}
			
			// Likes
			$likes_count = dbcount("(like_id)", DB_HELP_LIKE, "like_answer_id='".$data['answer_id']."'");
			
			echo "<div class='answer-main'>\n";
			echo "<div class='answer-wrap'>\n";
			echo "<div class='".$answer_wrap_style."'>".$cuser_avatar."<br />".$cuser_name."\n</div>\n";
			echo "<div class='".$answer_style."'>\n";
			echo "<div class='answer-body'>\n";
			echo parseubb(parsesmileys(nl2br($data['answer_message'])));
			echo "</div>\n<hr />\n";
			echo "<div class='bottom'>\n";
			echo "<span class='left'>\n";
			if ($solved == 0 && ($userdata['user_id'] == $question_user_id OR (iADMIN && checkrights("HLP")))) {
				echo "<a href='".FUSION_SELF."?question_id=".$_GET['question_id']."&amp;action=solve&amp;answer_id=".$data['answer_id']."'><button class='solve'>".$locale['HELP_solution']."</button></a>\n";
			}
			if ($data['answer_solution'] == 1 && ($userdata['user_id'] == $question_user_id OR (iADMIN && checkrights("HLP")))) {
				echo "<a href='".FUSION_SELF."?question_id=".$_GET['question_id']."&amp;action=unsolve&amp;answer_id=".$data['answer_id']."'><button class='unsolve'>".$locale['HELP_cancel']."</button></a>\n";
			}
			echo "<a href='".FUSION_SELF."?question_id=".$_GET['question_id']."&amp;action=like&amp;answer_id=".$data['answer_id']."'><button class='like'>".$locale['HELP_like']." ".$likes_count."</button></a>\n";
			echo "</span>\n";
			echo "<span class='right'>\n";
			echo showdate("longdate", $data['answer_datestamp']);
			if ($userdata['user_id'] == $data['answer_user_id'] OR (iADMIN && checkrights("HLP"))) {
			echo " &middot; <a href='".$HELP_PATH."edit_answer.php?answer_id=".$data['answer_id']."'>".$locale['HELP_edit']."</a>\n";
			}
			if (iADMIN && checkrights("HLP")) {
			echo "&middot; <a href='".FUSION_SELF."?question_id=".$_GET['question_id']."&amp;action=delanswer&amp;answer_id=".$data['answer_id']."' onclick=\"return confirm('".$locale['HELP_delete_warning']."');\">".$locale['HELP_delete']."</a>\n";
			}
			echo "</span>\n";
			echo "</div>\n";
			echo "</div>\n";
			echo "</div>\n";
			echo "</div>\n";
			}
		} else {
			echo "<br /><center>".$locale['HELP_no_answers']."</center>";
		}
		
		closetable();
		
		// Solve question by setting both question and answer solution field to 1
		if ((isset($_GET['action']) && $_GET['action'] == "solve") && (isset($_GET['answer_id']) && isnum($_GET['answer_id']))) {
			$check = dbquery("SELECT answer_id, question_id, answer_user_id, answer_solution 
							  FROM ".DB_HELP_A." WHERE question_id='".$question_id."' AND answer_id='".$_GET['answer_id']."' AND answer_solution='0'");
			if ($userdata['user_id'] == $question_user_id OR (iADMIN && checkrights("HLP"))) {
				if (dbrows($check) > 0) {
					$data = dbarray($check);
					$question_solved = dbquery("UPDATE ".DB_HELP_Q." SET question_solved='1' WHERE question_id='".$question_id."'");
					$answer_solution = dbquery("UPDATE ".DB_HELP_A." SET answer_solution='1' WHERE question_id='".$question_id."' AND answer_id='".$_GET['answer_id']."'");
					$update_profile = dbquery("UPDATE ".DB_USERS." SET user_help=user_help+1 WHERE user_id='".$data['answer_user_id']."'");
				}
			}
		redirect(FUSION_SELF."?question_id=".$_GET['question_id']);
		}
			
		// Reset both question and answer to unsolved
		if ((isset($_GET['action']) && $_GET['action'] == "unsolve") && (isset($_GET['answer_id']) && isnum($_GET['answer_id']))) {
			$check = dbquery("SELECT answer_id, question_id, answer_user_id, answer_solution 
							  FROM ".DB_HELP_A." WHERE question_id='".$question_id."' AND answer_id='".$_GET['answer_id']."' AND answer_solution='1'");
			if ($userdata['user_id'] == $question_user_id OR (iADMIN && checkrights("HLP"))) {
				if (dbrows($check) > 0) {
					$data = dbarray($check);
					$question_solved = dbquery("UPDATE ".DB_HELP_Q." SET question_solved='0' WHERE question_id='".$question_id."'");
					$answer_solution = dbquery("UPDATE ".DB_HELP_A." SET answer_solution='0' WHERE question_id='".$question_id."' AND answer_id='".$_GET['answer_id']."'");
					$update_profile = dbquery("UPDATE ".DB_USERS." SET user_help=user_help-1 WHERE user_id='".$data['answer_user_id']."'");
				}
			}
		redirect(FUSION_SELF."?question_id=".$_GET['question_id']);
		}
		
		// Like answer
		if (isset($_GET['action']) && $_GET['action'] == "like" && (isset($_GET['answer_id']) && isnum($_GET['answer_id']))) {
			if (iMEMBER) {
				$check = dbquery("SELECT * FROM ".DB_HELP_LIKE." WHERE like_answer_id='".$_GET['answer_id']."' AND like_user_id='".$userdata['user_id']."'");
				if (dbrows($check) == 0) {
					$like_answer = dbquery("INSERT INTO ".DB_HELP_LIKE." (like_user_id, like_answer_id, like_liked) VALUES ('".$userdata['user_id']."', '".$_GET['answer_id']."', '1');");
				} else {
					$like_answer = dbquery("DELETE FROM ".DB_HELP_LIKE." WHERE like_answer_id='".$_GET['answer_id']."' AND like_user_id='".$userdata['user_id']."'");
				}
				redirect(FUSION_SELF."?question_id=".$_GET['question_id']);
			} else {
				redirect(BASEDIR."login.php");
			}
		}
		
		// Delete question and answers
		if (isset($_GET['action']) && $_GET['action'] == "delquestion") {
			if (iADMIN && checkrights("HLP")) {
			$question_delete = dbquery("DELETE FROM ".DB_HELP_Q." WHERE  question_id='".$question_id."'");
			$answer_delete = dbquery("DELETE FROM ".DB_HELP_A." WHERE question_id='".$question_id."'");
			}
		redirect(FUSION_SELF);
		}
		
		// Delete answer and also reset question to unsolved if needed
		if ((isset($_GET['action']) && $_GET['action'] == "delanswer") && (isset($_GET['answer_id']) && isnum($_GET['answer_id']))) {
			if (iADMIN && checkrights("HLP")) {
			if ($solution_answer_id == $_GET['answer_id']) {
				$question_solved = dbquery("UPDATE ".DB_HELP_Q." SET question_solved='0' WHERE question_id='".$question_id."'");
			}
			$answer_delete = dbquery("DELETE FROM ".DB_HELP_A." WHERE answer_id='".$_GET['answer_id']."'");
			}
		redirect(FUSION_SELF."?question_id=".$_GET['question_id']);
		}
		
		
		// Post answers
		if ($solved == 0) {
		if (iMEMBER) {
			$message = "";
			
			if (isset($_POST['submit'])) {
			$answer_message = stripinput($_POST['answer_message']);
				if ($answer_message == NULL) {
				$message = $locale['HELP_answer_error'];
				} else {
					$add_answer = dbquery("INSERT INTO ".DB_HELP_A." (answer_message, question_id, answer_datestamp, answer_user_id) 
					VALUES ('".$answer_message."', '".$_GET['question_id']."', '".time()."', '".$userdata['user_id']."');");
					redirect(FUSION_SELF."?question_id=".$_GET['question_id']);
				}
			}
		
			if ($message != "") {  echo "<div class='admin-message'>".$message."</div>\n"; }
			
			opentable ($locale['HELP_answer_title']);

			require_once INCLUDES."bbcode_include.php";
			echo "<form id='inputform' name='inputform' method='post' action='".FUSION_SELF."?question_id=".$_GET['question_id']."' enctype='multipart/form-data'>\n
			<center><textarea name='answer_message' cols='60' rows='5' class='textbox' style='width:90%;'></textarea></center>\n
			<center>".display_bbcodes("100%", "answer_message", "inputform")."</center>\n";
			echo "<center><input type='submit' name='submit' value='".$locale['HELP_send']."' class='button'></center>\n";
			echo "</form>\n";
			
			closetable();
		} else {
			opentable ($locale['HELP_answer_title']);
			echo "<center>".$locale['HELP_answer_login']."</center>\n";
			closetable();
		}
		}

} else {
// Main page
global $userdata;

opentable($locale['HELP_title']);

echo "<table width='100%' cellpadding='0' cellspacing='0' border='0'>\n";
echo "<tr>\n<td>\n<a href='".$HELP_PATH."new_question.php'>\n
<button class='button'>".$locale['HELP_new_question']."</button>\n</a>\n";
echo "</td>\n";

echo "<td style='text-align:right'>\n";
echo $locale['HELP_filter_list']."\n";
echo "<select class='textbox' onchange='this.options[this.selectedIndex].value && (window.location = this.options[this.selectedIndex].value);'>\n";

	echo "<option value='".FUSION_SELF."'>".$locale['HELP_filter_none']."</option>\n";
    echo "<option value='".FUSION_SELF."?&amp;type=solved'";
	if (isset($_GET['type']) && $_GET['type'] == "solved") {echo " selected='selected'";}
	echo ">".$locale['HELP_filter_solved']."</option>\n";
    echo "<option value='".FUSION_SELF."?&amp;type=unsolved'";
	if (isset($_GET['type']) && $_GET['type'] == "unsolved") {echo " selected='selected'";}
	echo ">".$locale['HELP_filter_unsolved']."</option>\n";
    if (iMEMBER) {
	echo "<option value='".FUSION_SELF."?&amp;type=own'";
	if (isset($_GET['type']) && $_GET['type'] == "own") {echo " selected='selected'";}
	echo ">".$locale['HELP_filter_own']."</option>\n";
	}
	echo "<option value='".$HELP_PATH."cats.php'>".$locale['HELP_filter_cats']."</option>\n";

echo "</select>\n";
echo "</td>\n";

echo "<td style='text-align:right;width:230px;'>";
echo "<form name='searchform' method='get' action='".BASEDIR."search.php'>\n";
echo "<input type='hidden' name='stype' value='help' />\n";
echo "<input type='text' id='search' name='stext' placeholder='".$locale['HELP_search_text']."' class='textbox' style='width:160px;' />\n";
echo "<input type='submit' name='' value='".$locale['HELP_search_button']."' class='button'>\n";
echo "</form>\n";
echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";
echo "<br />\n";

// Filtering the list
if (isset($_GET['type']) && $_GET['type'] == "solved") {
	$filter = "WHERE question_solved='1'";
	$location = "?&amp;type=solved";
} elseif (isset($_GET['type']) && $_GET['type'] == "unsolved") {
	$filter = "WHERE question_solved='0'";
	$location = "?&amp;type=unsolved";
} elseif (isset($_GET['type']) && $_GET['type'] == "own" && iMEMBER) {
	$filter = "WHERE question_user_id='".$userdata['user_id']."'";
	$location = "?&amp;type=own";
} else {
	$filter = "";
	$location = "";
}

$result = dbquery("SELECT hq.*, cat.help_cat_id, cat.help_cat_name, scat.help_scat_id, scat.help_scat_name, 
				   users.user_id, users.user_name FROM ".DB_HELP_Q." hq 
				   LEFT JOIN ".DB_HELP_CAT." cat ON hq.question_cat=cat.help_cat_id 
				   LEFT JOIN ".DB_HELP_SUBCAT." scat ON hq.question_scat=scat.help_scat_id 
				   LEFT JOIN ".DB_USERS." users ON hq.question_user_id=users.user_id 
				   ".$filter." 
				   ORDER BY question_datestamp DESC");

$question_rows = dbrows($result); 
if (!isset($_GET['rowstart']) || !isnum($_GET['rowstart'])) { $_GET['rowstart'] = 0; }

	if ($question_rows) {
		$result = dbquery("SELECT hq.*, cat.help_cat_id, cat.help_cat_name, scat.help_scat_id, scat.help_scat_name, 
						   users.user_id, users.user_name FROM ".DB_HELP_Q." hq 
						   LEFT JOIN ".DB_HELP_CAT." cat ON hq.question_cat=cat.help_cat_id 
						   LEFT JOIN ".DB_HELP_SUBCAT." scat ON hq.question_scat=scat.help_scat_id 
						   LEFT JOIN ".DB_USERS." users ON hq.question_user_id=users.user_id 
						   ".$filter." 
						   ORDER BY question_datestamp DESC 
						   LIMIT ".$_GET['rowstart'].", ".$items_per_page."");
		
		while ($data = dbarray($result)) {
			
			include $HELP_PATH."includes/question_layout.php";
			
		}
	} else {
		if ($filter == "") {
			echo "<center>".$locale['HELP_question_no_result']."</center>\n";
		} else {
			echo "<center>".$locale['HELP_question_filtered_no_result']."</center>\n";
		}
	}

	if ($question_rows > $items_per_page) {
	echo "<div style='display:block;text-align:center;'>".makepagenav($_GET['rowstart'], $items_per_page, $question_rows, 3, FUSION_SELF.$location."&amp;")."</div>\n";
	}

closetable();

}

require_once THEMES."templates/footer.php";

?>